<?php
namespace InternetGalerie\Igshop2\Domain\Model;

use InternetGalerie\Igshop2\Domain\Repository\CountryRepository;
use InternetGalerie\Igshop2\Domain\Repository\CurrencyRepository;
use InternetGalerie\Igshop2\Domain\Repository\PaymentMethodRepository;
use TYPO3\CMS\Core\Context\Context;
use TYPO3\CMS\Core\Utility\GeneralUtility;

/**
 * Order
 */
class Order extends \TYPO3\CMS\Extbase\DomainObject\AbstractEntity {

  /**
   * tstamp
   *
   * @var int
   */
  protected $tstamp;

	/**
	 * userid
	 *
	 * @var integer
	 */
	protected $userid = 0;

	/**
	 * orderdate
	 *
	 * @var \DateTime
	 */
	protected $orderdate = NULL;

	/**
	 * total
	 *
	 * @var float
	 */
	protected $total = 0.0;

    /**
     * total
     *
     * @var float
     */
    protected $totalMembers = 0.0;

	/**
	 * customername
	 *
	 * @var string
	 */
	protected $customername = '';

	/**
	 * ordermail
	 *
	 * @var string
	 */
	protected $ordermail = '';

	/**
	 * orderinfo
	 *
	 * @var string
	 */
	protected $orderinfo = '';

	/**
	 * paymentmode
	 *
	 * @var string
	 */
	protected $paymentmode = '';

	/**
	 * paymentMethod
	 *
	 * @var \InternetGalerie\Igshop2\Domain\Model\PaymentMethod
	 */
	protected $paymentMethod = NULL;

	/**
	 * submitted
	 *
	 * @var integer
	 */
	protected $submitted = 0;

	/**
	 * done
	 *
	 * @var string
	 */
	protected $done = '';

	/**
	 * shippingType
	 *
	 * @var string
	 */
	protected $shippingType = '';

	/**
	 * shippingStatus
	 *
	 * @var string
	 */
	protected $shippingStatus = '';

	/**
	 * isMember
	 *
	 * @var boolean
	 */
	protected $isMember = FALSE;

	/**
	 * totalWithPorto
	 *
	 * @var float
	 */
	protected $totalWithPorto = 0.0;

	/**
	 * plzort
	 *
	 * @var string
	 */
	protected $plzort = '';

	/**
	 * strasse
	 *
	 * @var string
	 */
	protected $strasse = '';

	/**
	 * paid
	 *
	 * @var boolean
	 */
	protected $paid = FALSE;

	/**
	 * isOrder
	 *
	 * @var boolean
	 */
	protected $isOrder = FALSE;

	/**
	 * hasBillingAddress
	 *
	 * @var boolean
	 */
	protected $hasBillingAddress = FALSE;

	/**
	 * products
	 *
	 * @var \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\InternetGalerie\Igshop2\Domain\Model\OrderProduct>
	 * @TYPO3\CMS\Extbase\Annotation\ORM\Cascade remove
     * @TYPO3\CMS\Extbase\Annotation\ORM\Lazy
	 */
	protected $products = NULL;

	/**
	 * porto
	 *
	 * @var \InternetGalerie\Igshop2\Domain\Model\Porto
	 */
	protected $porto = NULL;

	/**
	 * country
	 *
	 * @var \InternetGalerie\Igshop2\Domain\Model\Country
	 */
	protected $country = NULL;

	/**
	 * countryText
	 *
	 * @var string
	 */
	protected $countryText ='';

	/**
	 * currency
	 *
	 * @var \InternetGalerie\Igshop2\Domain\Model\Currency
	 */
	protected $currency = NULL;

    /**
     * deliveryPeriod
     * @var \InternetGalerie\Igshop2\Domain\Model\DeliveryPeriod
     */
    protected $deliveryPeriod = null;

	/**
	 * mustCalculateTotal
	 *
	 * @var boolean
	 */
	protected $mustCalculateTotal = true;

    /**
     * mustCalculateTotal
     *
     * @var boolean
     */
    protected $mustCalculateTotalMembers = true;

	/**
	 * survey
	 *
	 * @var \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\InternetGalerie\Igshop2\Domain\Model\Survey>
     * @TYPO3\CMS\Extbase\Annotation\ORM\Lazy
	 */
	protected $survey = NULL;

    /**
     * confirmation
     *
     * @var \TYPO3\CMS\Extbase\Domain\Model\FileReference
     * @TYPO3\CMS\Extbase\Annotation\ORM\Cascade remove
     * @TYPO3\CMS\Extbase\Annotation\ORM\Lazy
     */
    protected $confirmation = NULL;

    /**
     * The delivery date
     *
     * @var \DateTime
     */
    protected $deliveryDate = null;


	/**
	 * __construct
	 */
	public function __construct() {
		//Do not remove the next line: It would break the functionality
		$this->initStorageObjects();
	}

	/**
	 * Initializes all ObjectStorage properties
	 * Do not modify this method!
	 * It will be rewritten on each save in the extension builder
	 * You may modify the constructor of this class instead
	 *
	 * @return void
	 */
	protected function initStorageObjects() {
		$this->products = new \TYPO3\CMS\Extbase\Persistence\ObjectStorage();
		$this->survey = new \TYPO3\CMS\Extbase\Persistence\ObjectStorage();
	}
	/**
	 * @return int $tstamp
	 */
	public function getTstamp() {
	  return $this->tstamp;
	}

	/**
	 * Returns the userid
	 *
	 * @return integer $userid
	 */
	public function getUserid() {
		return $this->userid;
	}

	/**
	 * Sets the userid
	 *
	 * @param integer $userid
	 * @return void
	 */
	public function setUserid($userid) {
		$this->userid = $userid;
	}

	/**
	 * Returns the orderdate
	 *
	 * @return \DateTime $orderdate
	 */
	public function getOrderdate() {
		return $this->orderdate;
	}

	/**
	 * Sets the orderdate
	 *
	 * @param \DateTime $orderdate
	 * @return void
	 */
	public function setOrderdate(\DateTime $orderdate) {
		$this->orderdate = $orderdate;
	}

	/**
	 * Returns the total
	 *
	 * @return float $total
	 */
	public function getTotal() {
        if(!$this->submitted || !$this->total) {
	        if ($this->mustCalculateTotal) {
    	        $this->calculateTotal();
            }
        }
	    return $this->total;
	}

    /**
     * Returns the total
     *
     * @return float $total
     */
    public function getTotalMembers() {
        if(!$this->submitted || !$this->total) {
	        if ($this->mustCalculateTotal) {
    	        $this->calculateTotalMembers();
            }
        }
      return $this->totalMembers;
    }

	/**
	 * Sets the total
	 *
	 * @param float $total
	 * @return void
	 */
	public function setTotal($total) {
	  $this->total = $total;
	}

	/**
	 * Returns the customername
	 *
	 * @return string $customername
	 */
	public function getCustomername() {
		return $this->customername;
	}

	/**
	 * Sets the customername
	 *
	 * @param string $customername
	 * @return void
	 */
	public function setCustomername($customername) {
		$this->customername = $customername;
	}

	/**
	 * Returns the ordermail
	 *
	 * @return string $ordermail
	 */
	public function getOrdermail() {
		return $this->ordermail;
	}

	/**
	 * Sets the ordermail
	 *
	 * @param string $ordermail
	 * @return void
	 */
	public function setOrdermail($ordermail) {
		$this->ordermail = $ordermail;
	}

	/**
	 * Returns the orderinfo
	 *
	 * @return string $orderinfo
	 */
	public function getOrderinfo() {
	  $address= unserialize($this->orderinfo);
	  return $address;
	}

	/**
	 * Sets the orderinfo
	 *
	 * @param array $orderinfo
	 * @return void
	 */
	public function setOrderinfo($orderinfo) {
      $country = $orderinfo['country'];
      if(is_object($country)) {
          $orderinfo['country'] = $country->getUid();
      }
      if($orderinfo['calcAddress']) {
        $calcAddressCountry = $orderinfo['calcAddress']['country'];
        if(is_object($calcAddressCountry)) {
            $orderinfo['calcAddress']['country'] = $calcAddressCountry->getUid();
        }
      }
	  $this->orderinfo = serialize($orderinfo);
	}

	/**
	 * Returns the paymentmode
	 *
	 * @return string $paymentmode
	 */
	public function getPaymentmode() {
		return $this->paymentmode;
	}

	/**
	 * Sets the paymentmode
	 *
	 * @param string $paymentmode
	 * @return void
	 */
	public function setPaymentmode($paymentmode) {
		$this->paymentmode = $paymentmode;
		//$this->mustCalculateTotal=true;
	}

 	/**
	 * Returns the paymentMethod
	 *
	 * @return \InternetGalerie\Igshop2\Domain\Model\PaymentMethod $paymentMethod
	 */
	public function getPaymentMethod() {
		return $this->paymentMethod;
	}
	/**
	 * Sets the paymentMethod
	 *
	 * @param \InternetGalerie\Igshop2\Domain\Model\PaymentMethod $paymentMethod
	 * @return void
	 */
	public function setPaymentMethod(\InternetGalerie\Igshop2\Domain\Model\PaymentMethod $paymentMethod) {
		$this->paymentMethod = $paymentMethod;
	}




	/**
	 * Returns the submitted
	 *
	 * @return integer $submitted
	 */
	public function getSubmitted() {
		return $this->submitted;
	}

	/**
	 * Sets the submitted
	 *
	 * @param integer $submitted
	 * @return void
	 */
	public function setSubmitted($submitted) {
		$this->submitted = $submitted;
	}

	/**
	 * Returns the done
	 *
	 * @return string $done
	 */
	public function getDone() {
		return $this->done;
	}

	/**
	 * Sets the done
	 *
	 * @param string $done
	 * @return void
	 */
	public function setDone($done) {
		$this->done = $done;
	}

	/**
	 * Returns the shippingType
	 *
	 * @return string $shippingType
	 */
	public function getShippingType() {
		return $this->shippingType;
	}

	/**
	 * Sets the shippingType
	 *
	 * @param string $shippingType
	 * @return void
	 */
	public function setShippingType($shippingType) {
		$this->shippingType = $shippingType;
		//$this->mustCalculateTotal=true;
	}

	/**
	 * Returns the shippingStatus
	 *
	 * @return string $shippingStatus
	 */
	public function getShippingStatus() {
		return $this->shippingStatus;
	}

	/**
	 * Sets the shippingStatus
	 *
	 * @param string $shippingStatus
	 * @return void
	 */
	public function setShippingStatus($shippingStatus) {
		$this->shippingStatus = $shippingStatus;
	}

	/**
	 * Returns the isMember
	 *
	 * @return boolean $isMember
	 */
	public function getIsMember() {
		return $this->isMember;
	}

	/**
	 * Sets the isMember
	 *
	 * @param boolean $isMember
	 * @return void
	 */
	public function setIsMember($isMember) {
	  if( $this->isMember != $isMember)
	    $this->mustCalculateTotal=true;

	  $this->isMember = $isMember;
	}

	/**
	 * Returns the boolean state of isMember
	 *
	 * @return boolean
	 */
	public function isIsMember() {
		return $this->isMember;
	}

	/**
	 * Returns the totalWithPorto
	 *
	 * @return float $totalWithPorto
	 */
	public function getTotalWithPorto() {
        if(!$this->submitted || !$this->totalWithPorto) {
    	    $this->calculateTotalWithPorto();
        }
	  return $this->totalWithPorto;
	}

	/**
	 * Sets the totalWithPorto
	 *
	 * @param float $totalWithPorto
	 * @return void
	 */
	public function setTotalWithPorto($totalWithPorto) {
		$this->totalWithPorto = $totalWithPorto;
	}

	/**
	 * Returns the plzort
	 *
	 * @return string $plzort
	 */
	public function getPlzort() {
		return $this->plzort;
	}

	/**
	 * Sets the plzort
	 *
	 * @param string $plzort
	 * @return void
	 */
	public function setPlzort($plzort) {
		$this->plzort = $plzort;
	}

	/**
	 * Returns the strasse
	 *
	 * @return string $strasse
	 */
	public function getStrasse() {
		return $this->strasse;
	}

	/**
	 * Sets the strasse
	 *
	 * @param string $strasse
	 * @return void
	 */
	public function setStrasse($strasse) {
		$this->strasse = $strasse;
	}

	/**
	 * Returns the paid
	 *
	 * @return boolean $paid
	 */
	public function getPaid() {
		return $this->paid;
	}

	/**
	 * Sets the paid
	 *
	 * @param boolean $paid
	 * @return void
	 */
	public function setPaid($paid) {
		$this->paid = $paid;
	}

	/**
	 * Returns the boolean state of paid
	 *
	 * @return boolean
	 */
	public function isPaid() {
		return $this->paid;
	}

	/**
	 * Returns the isOrder
	 *
	 * @return boolean $isOrder
	 */
	public function getIsOrder() {
		return $this->isOrder;
	}

	/**
	 * Sets the isOrder
	 *
	 * @param boolean $isOrder
	 * @return void
	 */
	public function setIsOrder($isOrder) {
		$this->isOrder = $isOrder;
	}

	/**
	 * Returns the boolean state of isOrder
	 *
	 * @return boolean
	 */
	public function isIsOrder() {
		return $this->isOrder;
	}

	/**
	 * Returns the hasBillingAddress
	 *
	 * @return boolean $hasBillingAddress
	 */
	public function getHasBillingAddress() {
		return $this->hasBillingAddress;
	}

	/**
	 * Sets the hasBillingAddress
	 *
	 * @param boolean $hasBillingAddress
	 * @return void
	 */
	public function setHasBillingAddress($hasBillingAddress) {
		$this->hasBillingAddress = $hasBillingAddress;
	}

	/**
	 * Returns the boolean state of hasBillingAddress
	 *
	 * @return boolean
	 */
	public function isHasBillingAddress() {
		return $this->hasBillingAddress;
	}

	/**
	 * Adds a OrderProduct
	 *
	 * @param \InternetGalerie\Igshop2\Domain\Model\OrderProduct $product
	 * @return void
	 */
	public function addProduct(\InternetGalerie\Igshop2\Domain\Model\OrderProduct $product) {
		$this->products->attach($product);
		$this->mustCalculateTotal=true;
	}

        /**
         * Adds a Product (entweder neues orderproduct oder falls schon bestehend Anzahl dazu addieren)
         *
         * @param \InternetGalerie\Igshop2\Domain\Model\Product $product
         * @return void
         */
    public function addNewProduct(\InternetGalerie\Igshop2\Domain\Model\Product $product, $options = [], $prodLimit) {

    	$newProduct = $this->getOrderProduct($product, $options, $prodLimit);
    	$similiarProduct = $this->getSimiliarProduct($newProduct);
        $canBeOrdered = true;
        if(isset($GLOBALS['TYPO3_CONF_VARS']['SC_OPTIONS']['igshop2_hooks']) && is_array($GLOBALS['TYPO3_CONF_VARS']['SC_OPTIONS']['igshop2_hooks']['hooks'])) {
            foreach ($GLOBALS['TYPO3_CONF_VARS']['SC_OPTIONS']['igshop2_hooks']['hooks'] as $classRef) {
                $hookObj = GeneralUtility::makeInstance($classRef);
                if (method_exists($hookObj, 'checkProductState')) {
                    $canBeOrdered = !$hookObj->checkProductState($product);
                }
            }
        }

        if(!$canBeOrdered) {
            return;
        }

        // Produkt ist neu
        if ($similiarProduct===false) {
    	    $this->addProduct($newProduct);
        } else {
    	    // Produkt schon in Bestellung vorhanden
    	    // dynamisches limit, gegeben durch input form
    	    $simAmount = $similiarProduct->getAmount();
    	    $newProdAmount = $newProduct->getAmount();
    	    if($prodLimit){
    	        $newAmount = min($prodLimit, $simAmount + $newProdAmount);
    	    }else{
    	        $newAmount = $simAmount + $newProdAmount;
    	    }
            if($product->getMaxAmount() > 0) {
                $newAmount = min($product->getMaxAmount(), $newAmount);
            }
    	    $similiarProduct->setAmount($newAmount);
    	    $similiarProduct->calcPrice($this->currency, $this->isMember);
        }

        $this->setDeliveryPeriod($this->getMaxDeliveryPeriod());
    }


        /**
         * change a Product
         *
         * @param \InternetGalerie\Igshop2\Domain\Model\OrderProduct $product
         * @return boolean product was deleted
         */
    public function changeProductQuantity(\InternetGalerie\Igshop2\Domain\Model\OrderProduct $orderProduct, $newQuantity) {
        $deleteProduct = false;
        if($newQuantity <= 0){
    	    $deleteProduct = true;
    	    $this->removeProduct($orderProduct);
        }else{
    	    $orderProduct->setAmount($newQuantity);
    	    $orderProduct->calcPrice($this->currency, $this->isMember);
    	    $this->mustCalculateTotal = true;
        }
        return $deleteProduct;
    }




	protected function getOrderProduct(\InternetGalerie\Igshop2\Domain\Model\Product $product, $options = [], $prodLimit) {
		if ($options['amount'] <= 0) {
		  //$this->forward("delete", "", "", array("productUid" => $product->getUid()));
		}
		$newProduct = GeneralUtility::makeInstance(OrderProduct::class);
		//$newProduct = \TYPO3\CMS\Core\Utility\GeneralUtility::makeInstance("InternetGalerie\\Igshop2\\Domain\\Model\\OrderProduct");
		if($prodLimit > 0){
			$newProduct->setAmount(min($prodLimit, $options['amount']));
		}else{
			$newProduct->setAmount($options['amount']);
		}
		if($product->getMaxAmount() > 0 && $newProduct->getAmount()>$product->getMaxAmount()  ) {
		  $newProduct->setAmount($product->getMaxAmount());
		}
		unset($options['amount']);
		$newProduct->setProdOptions(serialize($options));
		$newProduct->setProduct($product);
		$newProduct->calcPrice($this->currency, $this->isMember);
		return $newProduct;
	}

	/**
	 * Removes a OrderProduct
	 *
	 * @param \InternetGalerie\Igshop2\Domain\Model\OrderProduct $productToRemove The OrderProduct to be removed
	 * @return void
	 */
	public function removeProduct(\InternetGalerie\Igshop2\Domain\Model\OrderProduct $productToRemove) {
		$this->products->detach($productToRemove);
		$this->mustCalculateTotal=true;
	}

	/**
	 * Returns the products
	 *
	 * @return \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\InternetGalerie\Igshop2\Domain\Model\OrderProduct> $products
	 */
	public function getProducts() {
		return $this->products;
	}

	/**
	 * Returns the number of products
	 *
	 * @return \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\InternetGalerie\Igshop2\Domain\Model\OrderProduct> $products
	 */
	public function getTotalProductsCount() {
	 	$totalProducts = 0;
	 	foreach($this->products AS $product){
	 		$totalProducts += $product->getAmount();
	 	}

		return $totalProducts;
	}
	public function getTotalProductsPrice() {
	  return $this->getTotal();
	}

    /**
     * Returns a Product with the same Options
     * @param int $productUid
     * @param string $prodOptions
     * @return \InternetGalerie\Igshop2\Domain\Model\OrderProduct $orderProduct
     */
    public function getProduct($productUid, $prodOptions){

        foreach($this->products AS $product){
            if($product->getProduct()->getUid() == $productUid && $product->getProdOptions() == $prodOptions){
                return $product;
            }
        }

        return false;
    }
    /**
     * Returns the OrderProduct with the given uid from this order
     * @param int $orderProductUid
     * @return \InternetGalerie\Igshop2\Domain\Model\OrderProduct $orderProduct|null
     */
    public function getOrderProductByUid($orderProductUid){
        foreach($this->products AS $orderProduct){
            if($orderProduct->getUid()==$orderProductUid) {
                return $orderProduct;
            }
        }
        return null;
    }
	/**
	 * Sets the products
	 *
	 * @param \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\InternetGalerie\Igshop2\Domain\Model\OrderProduct> $products
	 * @return void
	 */
	public function setProducts(\TYPO3\CMS\Extbase\Persistence\ObjectStorage $products) {
		$this->products = $products;
		$this->mustCalculateTotal=true;
	}




 	/**
	 * Returns the porto
	 *
	 * @return \InternetGalerie\Igshop2\Domain\Model\Porto $porto
	 */
	public function getPorto() {
		return $this->porto;
	}
 	/**
	 * is the current porto for country $country
	 *
	 * @return bool
	 */
	public function isPortoValidWithCountry( $country ) {
        return $this->porto && $country && $this->porto->hasCountry($country);
	}
 	/**
	 * Returns the porto.price
	 *
	 * @return string
	 */
	public function getPortoPrice() {
        //echo($this->getCurrency() .','. $this->getTotalProductsPrice() .','.$this->getTotalProductsCount());
        if(is_object($this->porto)) {
            if( $this->getCurrency()->getShort()=='CHF')
                return $this->porto->getCurrentPrice($this->getTotalProductsPrice(),$this->getTotalProductsCount());
            else
                return $this->porto->getCurrentPriceEuro($this->getTotalProductsPrice(),$this->getTotalProductsCount());
        }
        else
            return '';
	}

	/**
	 * Sets the porto
	 *
	 * @param \InternetGalerie\Igshop2\Domain\Model\Porto $porto
	 * @return void
	 */
	public function setPorto(\InternetGalerie\Igshop2\Domain\Model\Porto $porto) {
		$this->porto = $porto;
	}

	/**
	 * Removes the porto
	 *
	 * @return void
	 */
	public function removePorto() {
		$this->porto = null;
	}

 	/**
	 * Returns the porto.price
	 *
	 * @return string
	 */
	public function getPortoDescription() {
          if(is_object($this->porto)) {
	    //echo($this->getCurrency() .','. $this->getTotalProductsPrice() .','.$this->getTotalProductsCount());
	    $search = [ '{currency.short}','{currency.name}','{currency.symbol}','{order.portoPricesDiff}'];
	    $replace = [$this->getCurrency()->getShort(),$this->getCurrency()->getName(),$this->getCurrency()->getSymbol(),$this->getPortoPricesDiff()];

	    // @TODO Euro Preise bei amount_min und amount_max
	    return str_replace($search, $replace, $this->porto->getCurrentDescription($this->getTotalProductsPrice(),$this->getTotalProductsCount()));
	  } else {
            return '';
          }

	}
        /**
         * Returns the Betrag bis nächste Porto Stufe erreicht wird
         *
         * @return string
         */

	public function getPortoPricesDiff() {
          if(is_object($this->porto)) {
	    $next_price = $this->porto->getNextPrice($this->getTotalProductsPrice(),$this->getTotalProductsCount());
	    $current_price = $this->getTotalProductsPrice();
	    if( $next_price && $next_price >$current_price)
	      return number_format($next_price - $current_price,2);
	  }
	  return '';
	}

	/**
	 * Returns the country
	 *
	 * @return \InternetGalerie\Igshop2\Domain\Model\Country $country
	 */
	public function getCountry() {
		return $this->country;
	}

	/**
	 * Sets the country
	 *
	 * @param \InternetGalerie\Igshop2\Domain\Model\Country $country
	 * @return void
	 */
	public function setCountry(\InternetGalerie\Igshop2\Domain\Model\Country $country) {
		$this->country = $country;
		//$this->mustCalculateTotal=true;
	}

	/**
	 * Returns the countryText
	 *
	 * @return string $countryText
	 */
	public function getCountryText() {
		return $this->countryText;
	}
	/**
	 * Returns the country object (entweder direkt Objekt oder passendes zu countryText - sonst null)
	 *
	 * @param boolean $countryAsUid Country Objekt verwenden sonst Text
	 * @return string $country
	 */
	public function getCountryObject($countryAsUid) {
	  if($countryAsUid)
	    return $this->country;

      // really old.....
	  $country=null;
	  $countryText = $this->getCountryText();

	  // @TODO DA - muss weg
	  if(GeneralUtility::makeInstance(Context::class)->getPropertyFromAspect('language', 'id') == 2){
	    if( $countryText=='Schweiz')
	      $countryText='Suisse';
	    if( $countryText=='Deutschland')
	      $countryText='Allemagne';
	  } else {
	    if( $countryText=='Suisse')
	      $countryText='Schweiz';
	    if( $countryText=='Allemagne')
	      $countryText='Deutschland';
	  }
	  $countryRepository = GeneralUtility::makeInstance(CountryRepository::class);
	  $countryRes=$countryRepository->findByName($countryText);
	  if(count($countryRes)>=1)
	    $country=$countryRes->getFirst();

	  return $country;
	}

    public function getCalcCountry()
	{
		$countryRepository = GeneralUtility::makeInstance(CountryRepository::class);
        $country = $countryRepository->findByUid($this->getOrderinfo()['calcAddress']['country']);
        return $country;
    }

	/**
	 * Sets the countryText
	 *
	 * @param string $countryText
	 * @return void
	 */
	public function setCountryText($countryText) {
		$this->countryText = $countryText;
	}


	/**
	 * Returns the currency
	 *
	 * @return \InternetGalerie\Igshop2\Domain\Model\Currency $currency
	 */
	public function getCurrency() {
		return $this->currency;
	}

	/**
	 * Sets the currency
	 *
	 * @param \InternetGalerie\Igshop2\Domain\Model\Currency $currency
	 * @return void
	 */
	public function setCurrency(\InternetGalerie\Igshop2\Domain\Model\Currency $currency) {
	  if( $this->currency != $currency) {
	    $this->currency = $currency;
	    $this->mustCalculateTotal=true;
	    // @TODO muss weg
	    foreach( $this->getProducts()as $op) {
	      $op->calcPrice($this->currency, $this->getIsMember());
	    }
	  }

	}

    /**
     * @return \InternetGalerie\Igshop2\Domain\Model\DeliveryPeriod
     */
    public function getDeliveryPeriod(){
        return $this->deliveryPeriod;
    }

    /**
     * @param \InternetGalerie\Igshop2\Domain\Model\State $state
     * @return void
     */
    public function setDeliveryPeriod($deliveryPeriod){
        $this->deliveryPeriod = $deliveryPeriod;
    }

    public function getMaxDeliveryPeriod($productToRemove = null) {
        $maxDeliveryPeriod = $this->getDeliveryPeriod();
        $maxPriority = $this->getDeliveryPeriod() ? $this->getDeliveryPeriod()->getPriority() : 0;

        if($productToRemove) {
            $maxDeliveryPeriod = null;
            $maxPriority = 0;
        }

        foreach($this->getProducts() as $orderProduct) {
            if($productToRemove && $orderProduct->getUid() == $productToRemove->getUid()) {
                continue;
            }
            $product = $orderProduct->getProduct();

            if($product->getDeliveryPeriod()) {
                $maxPriority = max($maxPriority, $product->getDeliveryPeriod()->getPriority());
            }

            if($orderProduct->getOptionWithPrice() && $orderProduct->getOptionWithPrice()->getDeliveryPeriod()) {
                $maxPriority = max($maxPriority, $orderProduct->getOptionWithPrice()->getDeliveryPeriod()->getPriority());
            }
            if($product->getDeliveryPeriod() && $maxPriority == $product->getDeliveryPeriod()->getPriority()) {
                $maxDeliveryPeriod = $product->getDeliveryPeriod();
            } else if($orderProduct->getOptionWithPrice() && $orderProduct->getOptionWithPrice()->getDeliveryPeriod() && $maxPriority == $orderProduct->getOptionWithPrice()->getDeliveryPeriod()->getPriority()) {
                $maxDeliveryPeriod = $orderProduct->getOptionWithPrice()->getDeliveryPeriod();
            }
        }

        return $maxDeliveryPeriod;
    }


	/**
	 * Sets the currency per Uid (from session)
	 *
	 * @param integer $currency
	 * @return void
	 */
	public function setCurrencyByUid($currencyUid) {
	  if(intval($currencyUid)>0) {
		$currencyRepository = GeneralUtility::makeInstance(CurrencyRepository::class);
	    $currency=$currencyRepository->findOneByUid($currencyUid);
	    //$currencyRes=$this->currencyRepository->findByUid($currencyUid);
	    //$currency=$currencyRes->getFirst();
	    if($currency) {
	      $this->setCurrency($currency);
	      return $currency;
	    }
	  }
	  return false;
	}




	/**
	 * Returns the total amount of products
	 *
	 * @return int $totalProducts
	 */
	 public function getTotalProductsAmount(){
	   return $this->getTotalProductsCount();
	 }

	 /**
	 * Function getSimilarproduct
	 *
	 * Searches a product who has the same UID and the same options as the given Orderproduct
	 * @param \InternetGalerie\Igshop2\Domain\Model\OrderProduct $product
	 * @return mixed $orderProduct Product or false
	 *
	 */
	 public function getSimiliarProduct(\InternetGalerie\Igshop2\Domain\Model\OrderProduct $product){
	 	foreach ($this->getProducts() as $orderProduct) {
			if ($orderProduct->getProduct()->getUid() == $product->getProduct()->getUid() && $orderProduct->getProdOptions() == $product->getProdOptions()) {
				return $orderProduct;
			}
		}
		return false;
	 }


	 public function saveAddress($address, $settings){


	 	if ($address['country']) {
		  if($settings['countryAsUid'] )
		    $this->setCountry($address['country']);
		  else
		    $this->setCountryText($address['country']);
		}

		if ($address['firstName'])
			$this->setCustomername($address['firstName']);

		if ($address['mail'])
			$this->setOrdermail($address['mail']);

		if ($address['address'])
			$this->setStrasse($address['address']);

		if ($address['zip'] && $address['city'])
			$this->setPlzort($address['zip']." ".$address["city"]);

		if (is_array($address)){
			if(key_exists("calcAddress", $address)){
				$calcAddress = $address['calcAddress'];
				unset($address['calcAddress']);
			}

			$orderInfo = unserialize($this->orderinfo);
			foreach($address AS $field => $value){
					$orderInfo[$field] = $address[$field];
			}
            $orderInfo['extraBillingAddress'] = 0;
            if(isset($orderInfo['isCalcAddress']) && $orderInfo['isCalcAddress']) {
                $address['extraBillingAddress'] = true;
                $orderInfo['extraBillingAddress'] = 1;
            }
			if(isset($address['extraBillingAddress']) && $address['extraBillingAddress'])
			  $orderInfo['isCalcAddress']=1;
			else
			  $orderInfo['isCalcAddress']=0;
			$this->setHasBillingAddress( $this->extraBillingAddress($address, $settings));
			if(is_array($calcAddress)){
				foreach($calcAddress AS $field => $value){
					$orderInfo['calcAddress'][$field] = $calcAddress[$field];
				}
			}

			$this->setOrderinfo($orderInfo);
		}

		if (isset($address['payment']) && $address['payment']) {
            $paymentMethodRepository= GeneralUtility::makeInstance(PaymentMethodRepository::class);
            $paymentMethod=$paymentMethodRepository->findByUid($address['payment']);
			$this->setPaymentMethod($paymentMethod);
        }
	 }

	 public function hasProductWithoutPorto(){
	 	foreach($this->products AS $orderProduct){
	 		$product = $orderProduct->getProduct();
			if($product->isNoPorto())
				return true;
	 	}
		return false;
	 }


	 /**
	 * Returns the total amount of products
	 *
	 * @return int $totalProducts
	 */




	 /**
	  * Sets the price for the order for all ordered Products
	  * @param boolean $isMember
	  * @return void
	  */
	 public function calcAllOrderProductPrices(){
	 	foreach($this->getProducts() AS $product){
		  $product->calcPrice($this->getCurrency(), $this->isMember);
	 	}
	 }

     /**
      * Sets the price for the order for all ordered Products
      * @param boolean $isMember
      * @return void
      */
     public function calcAllOrderProductMemberPrices(){
        foreach($this->getProducts() AS $product){
          $product->calcPrice($this->getCurrency(), true);
        }
     }

	 protected function calculateTotal() {
	 	$total = 0;
		$this->calcAllOrderProductPrices();
	 	foreach($this->products AS $orderProduct){
	 		$options = unserialize($orderProduct->getProdOptions());
	 		$product = $orderProduct->getProduct();

            if($product) {
                $orderProductPrice = $product->getFinalPrice( $this->getCurrency(), $options['optionWithPrice'] ?? null, $orderProduct->getAmount(), false, $this->isMember);

    	 		$total += $orderProductPrice * $orderProduct->getAmount();
            }
	 	}
		$this->total = $total;
	 }

     protected function calculateTotalMembers() {
        $total = 0;
        $this->calcAllOrderProductMemberPrices();
        foreach($this->products AS $orderProduct){
            $options = unserialize($orderProduct->getProdOptions());
            $product = $orderProduct->getProduct();
            $orderProductPrice = $product->getFinalPrice( $this->getCurrency(), $options['optionWithPrice'] ?? null, $orderProduct->getAmount(), false, true);

            $total += $orderProductPrice * $orderProduct->getAmount();
        }
        $this->totalMembers = $total;
     }

	 //public function calcTotalWithPorto(){
	 public function calculateTotalWithPorto(){
	 	if($this->getPorto() != null){
		  $this->totalWithPorto = $this->getTotal() + $this->getPorto()->getCurrentPrice($this->getTotalProductsPrice(),$this->getTotalProductsCount());
	 	}else{
		  $this->totalWithPorto = $this->getTotal();
	 	}
	 }

	// Extra Rechnungsadresse angewählt
	 public function extraBillingAddress( $address, $settings ) {
	  return $settings['differentAddresses'] && (isset($address['extraBillingAddress']) && $address['extraBillingAddress'])  || (isset($address['sameBillingAddress']) && !$address['sameBillingAddress']) && $address["payment"] != 'PayPal';
	  // $this->settings['differentAddresses'] &&
	}

	 // @TODO noch sinnvoller machen
	 public function hasPorto(){
	   return $this->getPorto();
	 }
	/**
	 * Adds a Survey
	 *
	 * @param \InternetGalerie\Igshop2\Domain\Model\Survey $survey
	 * @return void
	 */
	public function addSurvey(\InternetGalerie\Igshop2\Domain\Model\Survey $survey) {
		$this->survey->attach($survey);
	}

	/**
	 * Removes a Survey
	 *
	 * @param \InternetGalerie\Igshop2\Domain\Model\Survey $surveyToRemove The Survey to be removed
	 * @return void
	 */
	public function removeSurvey(\InternetGalerie\Igshop2\Domain\Model\Survey $surveyToRemove) {
		$this->survey->detach($surveyToRemove);
	}

	/**
	 * Returns the survey
	 *
	 * @return \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\InternetGalerie\Igshop2\Domain\Model\Survey> $survey
	 */
	public function getSurvey() {
		return $this->survey;
	}

	/**
	 * Sets the survey
	 *
	 * @param \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\InternetGalerie\Igshop2\Domain\Model\Survey> $survey
	 * @return void
	 */
	public function setSurvey(\TYPO3\CMS\Extbase\Persistence\ObjectStorage $survey) {
		$this->survey = $survey;
	}


    /**
     * Adds a confirmation
     *
     * @param \TYPO3\CMS\Extbase\Domain\Model\FileReference $confirmation
     * @return void
     */
    /*public function addConfirmation(\TYPO3\CMS\Extbase\Domain\Model\FileReference $confirmation) {
        $this->confirmation->attach($confirmation);
    }*/

    /**
     * Removes a confirmation
     *
     * @param \TYPO3\CMS\Extbase\Domain\Model\FileReference $confirmationToRemove The FileReference to be removed
     * @return void
     */
    /*public function removeConfirmation(\TYPO3\CMS\Extbase\Domain\Model\FileReference $confirmationToRemove) {
        $this->confirmation->detach($confirmationToRemove);
    }*/

    /**
     * Returns the confirmation
     *
     * @return \TYPO3\CMS\Extbase\Domain\Model\FileReference $confirmation
     */
    public function getConfirmation() {
        return $this->confirmation;
    }

    /**
     * Sets the confirmation
     *
     * @param \TYPO3\CMS\Extbase\Domain\Model\FileReference $confirmation
     * @return void
     */
    public function setConfirmation(\TYPO3\CMS\Extbase\Domain\Model\FileReference $confirmation) {
        $this->confirmation = $confirmation;
    }

    /**
     * Returns the
     */
    public function getVat() {
        $total = $this->getTotal();
        return $total - ($total / 1.077);
    }

    /**
     * Get the value of The delivery date
     *
     * @return \DateTime
     */
    public function getDeliveryDate()
    {
        return $this->deliveryDate;
    }

    /**
     * Set the value of The delivery date
     *
     * @param \DateTime $deliveryDate
     *
     * @return self
     */
    public function setDeliveryDate(\DateTime $deliveryDate = null)
    {
        $this->deliveryDate = $deliveryDate;

        return $this;
    }

}
