<?php
namespace InternetGalerie\Igshop2\Domain\Model;

/***
 *
 * This file is part of the "Ig Shop" Extension for TYPO3 CMS.
 *
 * For the full copyright and license information, please read the
 * LICENSE.txt file that was distributed with this source code.
 *
 *  (c) 2019
 *
 ***/

/**
 * PaymentMethod
 */
class PaymentMethod extends \TYPO3\CMS\Extbase\DomainObject\AbstractEntity
{
    /**
     * name
     *
     * @var string
     */
    protected $name = '';

    /**
     * controller
     *
     * @var string
     */
    protected $controller = '';

    /**
     * code
     *
     * @var string
     */
    protected $code = '';

    /**
     * description
     *
     * @var string
     */
    protected $description = '';

    /**
     * mailtext
     *
     * @var string
     */
    protected $mailtext = '';

    /**
     * noPorto
     *
     * @var bool
     */
    protected $noPorto = false;

    /**
     * Returns the name
     *
     * @return string $name
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * Sets the name
     *
     * @param string $name
     * @return void
     */
    public function setName($name)
    {
        $this->name = $name;
    }

    /**
     * Returns the controller
     *
     * @return string $controller
     */
    public function getController()
    {
        return $this->controller;
    }

    /**
     * Sets the controller
     *
     * @param string $controller
     * @return void
     */
    public function setController($controller)
    {
        $this->controller = $controller;
    }

    /**
     * Returns the code
     *
     * @return string $code
     */
    public function getCode()
    {
        return $this->code;
    }

    /**
     * Sets the code
     *
     * @param string $code
     * @return void
     */
    public function setCode($code)
    {
        $this->code = $code;
    }

    /**
     * Returns the description
     *
     * @return string $description
     */
    public function getDescription()
    {
        return $this->description;
    }

    /**
     * Sets the description
     *
     * @param string $description
     * @return void
     */
    public function setDescription($description)
    {
        $this->description = $description;
    }

    /**
     * Returns the mailtext
     *
     * @return string $mailtext
     */
    public function getMailtext()
    {
        return $this->mailtext;
    }

    /**
     * Sets the mailtext
     *
     * @param string $mailtext
     * @return void
     */
    public function setMailtext($mailtext)
    {
        $this->mailtext = $mailtext;
    }

    /**
     * Returns the noPorto
     *
     * @return bool $noPorto
     */
    public function getNoPorto()
    {
        return $this->noPorto;
    }

    /**
     * Sets the noPorto
     *
     * @param bool $noPorto
     * @return void
     */
    public function setNoPorto($noPorto)
    {
        $this->noPorto = $noPorto;
    }

    /**
     * Returns the boolean state of noPorto
     *
     * @return bool
     */
    public function isNoPorto()
    {
        return $this->noPorto;
    }
}
