<?php
namespace InternetGalerie\Igshop2\Domain\Model;


/***************************************************************
 *
 *  Copyright notice
 *
 *  (c) 2015
 *
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/

/**
 * Productprice
 */
class Productprice extends \TYPO3\CMS\Extbase\DomainObject\AbstractEntity {

	/**
	 * price
	 *
	 * @var float
	 */
	protected $price;

	/**
	 * isSpecialPrice
	 *
	 * @var boolean
	 */
	protected $isSpecialPrice = FALSE;

	/**
	 * amount
	 *
	 * @var integer
	 */
	protected $amount = 0;

	/**
	 * priceEuro
	 *
	 * @var float
	 */
	protected $priceEuro;

	/**
	 * sorting
	 *
	 * @var integer
	 */
	protected $sorting = 0;

	/**
	 * currency
	 *
	 * @var \InternetGalerie\Igshop2\Domain\Model\Currency
     * @TYPO3\CMS\Extbase\Annotation\ORM\Lazy
	 */
	protected $currency = NULL;

	/**
	 * userGroups
	 *
	 * @var \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\Internetgalerie\IgFrontendUser\Domain\Model\FrontendUserGroup>
     * @TYPO3\CMS\Extbase\Annotation\ORM\Lazy
	 */
	protected $userGroups = NULL;

	/**
	 * image
	 *
	 * @var \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\TYPO3\CMS\Extbase\Domain\Model\FileReference>
	 * @TYPO3\CMS\Extbase\Annotation\ORM\Cascade remove
	 */
	protected $image = NULL;

	/**
	 * __construct
	 */
	public function __construct() {
		//Do not remove the next line: It would break the functionality
		$this->initStorageObjects();
	}

	/**
	 * Initializes all ObjectStorage properties
	 * Do not modify this method!
	 * It will be rewritten on each save in the extension builder
	 * You may modify the constructor of this class instead
	 *
	 * @return void
	 */
	protected function initStorageObjects() {
		$this->userGroups = new \TYPO3\CMS\Extbase\Persistence\ObjectStorage();
		$this->image = new \TYPO3\CMS\Extbase\Persistence\ObjectStorage();
	}

	/**
	 * Returns the price
	 *
	 * @return float $price
	 */
	public function getPrice() {
		return $this->price;
	}

	/**
	 * Sets the price
	 *
	 * @param float $price
	 * @return void
	 */
	public function setPrice($price) {
		$this->price = $price;
	}

	/**
	 * Returns the isSpecialPrice
	 *
	 * @return boolean $isSpecialPrice
	 */
	public function getIsSpecialPrice() {
		return $this->isSpecialPrice;
	}

	/**
	 * Sets the isSpecialPrice
	 *
	 * @param boolean $isSpecialPrice
	 * @return void
	 */
	public function setIsSpecialPrice($isSpecialPrice) {
		$this->isSpecialPrice = $isSpecialPrice;
	}

	/**
	 * Returns the boolean state of isSpecialPrice
	 *
	 * @return boolean
	 */
	public function isIsSpecialPrice() {
		return $this->isSpecialPrice;
	}

	/**
	 * Returns the amount
	 *
	 * @return integer $amount
	 */
	public function getAmount() {
		return $this->amount;
	}

	/**
	 * Sets the amount
	 *
	 * @param integer $amount
	 * @return void
	 */
	public function setAmount($amount) {
		$this->amount = $amount;
	}

	/**
	 * Returns the priceEuro
	 *
	 * @return float $priceEuro
	 */
	public function getPriceEuro() {
		return $this->priceEuro;
	}

	/**
	 * Sets the priceEuro
	 *
	 * @param float $priceEuro
	 * @return void
	 */
	public function setPriceEuro($priceEuro) {
		$this->priceEuro = $priceEuro;
	}

	/**
	 * Returns the sorting
	 *
	 * @return integer $sorting
	 */
	public function getSorting() {
		return $this->sorting;
	}

	/**
	 * Sets the sorting
	 *
	 * @param integer $sorting
	 * @return void
	 */
	public function setSorting($sorting) {
		$this->sorting = $sorting;
	}

	/**
	 * Returns the currency
	 *
	 * @return \InternetGalerie\Igshop2\Domain\Model\Currency $currency
	 */
	public function getCurrency() {
		return $this->currency;
	}

	/**
	 * Sets the currency
	 *
	 * @param \InternetGalerie\Igshop2\Domain\Model\Currency $currency
	 * @return void
	 */
	public function setCurrency(\InternetGalerie\Igshop2\Domain\Model\Currency $currency) {
		$this->currency = $currency;
	}

	/**
	 * Adds a FrontendUserGroup
	 *
	 * @param \Internetgalerie\IgFrontendUser\Domain\Model\FrontendUserGroup $userGroup
	 * @return void
	 */
	public function addUserGroup(\Internetgalerie\IgFrontendUser\Domain\Model\FrontendUserGroup $userGroup) {
		$this->userGroups->attach($userGroup);
	}

	/**
	 * Removes a FrontendUserGroup
	 *
	 * @param \Internetgalerie\IgFrontendUser\Domain\Model\FrontendUserGroup $userGroupToRemove The FrontendUserGroup to be removed
	 * @return void
	 */
	public function removeUserGroup(\Internetgalerie\IgFrontendUser\Domain\Model\FrontendUserGroup $userGroupToRemove) {
		$this->userGroups->detach($userGroupToRemove);
	}

	/**
	 * Returns the userGroups
	 *
	 * @return \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\Internetgalerie\IgFrontendUser\Domain\Model\FrontendUserGroup> $userGroups
	 */
	public function getUserGroups() {
		return $this->userGroups;
	}

	/**
	 * Sets the userGroups
	 *
	 * @param \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\Internetgalerie\IgFrontendUser\Domain\Model\FrontendUserGroup> $userGroups
	 * @return void
	 */
	public function setUserGroups(\TYPO3\CMS\Extbase\Persistence\ObjectStorage $userGroups) {
		$this->userGroups = $userGroups;
	}

	/**
	 * Adds a FileReference
	 *
	 * @param \TYPO3\CMS\Extbase\Domain\Model\FileReference $image
	 * @return void
	 */
	public function addImage(\TYPO3\CMS\Extbase\Domain\Model\FileReference $image) {
		$this->image->attach($image);
	}

	/**
	 * Removes a FileReference
	 *
	 * @param \TYPO3\CMS\Extbase\Domain\Model\FileReference $imageToRemove The FileReference to be removed
	 * @return void
	 */
	public function removeImage(\TYPO3\CMS\Extbase\Domain\Model\FileReference $imageToRemove) {
		$this->image->detach($imageToRemove);
	}

	/**
	 * Returns the image
	 *
	 * @return \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\TYPO3\CMS\Extbase\Domain\Model\FileReference> $image
	 */
	public function getImage() {
		return $this->image;
	}
        /**
         * Returns the imageLocalized
         *
         * @return \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\TYPO3\CMS\Extbase\Domain\Model\FileReference> $image
         */
        public function getImageLocalized() {
	  //return $this->getImage();
          return $this->getLocalized( 'image' );
        }

	/**
	 * Returns the mainimage
	 *
	 * @return \TYPO3\CMS\Extbase\Domain\Model\FileReference $image
	 */
	public function getMainImageLocalized() {
	  $imgs = $this->getImageLocalized();
	  return count($imgs) >0 ? $imgs[0] : null;
	}


	/**
	 * Sets the image
	 *
	 * @param \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\TYPO3\CMS\Extbase\Domain\Model\FileReference> $image
	 * @return void
	 */
	public function setImage(\TYPO3\CMS\Extbase\Persistence\ObjectStorage $image) {
		$this->image = $image;
	}

}
