var wordSearch = false;

$('#indexedsearch').on('submit', function(e) {
    if(!wordSearch) {
        $('.shopSearchString').val($('input.shop-ajax-search').val());
    } else {
        $('.shopSearchString').val('');
    }
});

jQuery(document).ready(function () {
    if (jQuery('input.shop-ajax-search').length > 0) {
        initIndexSearchAutocomplete();
    }
});

var indexedSearchAutocompleteDebounceInterval = null; // Used to reduce the amount of querys
function initIndexSearchAutocomplete() {
    jQuery('input.shop-ajax-search')
        .on('keypress keyup', indexedSearchAutocomplete).attr('autocomplete', 'off');

    $('*').click(function () {
        var elem = $(this);

        var targetClass = '.search-autocomplete-results';

        if ($('.search-autocomplete-results > *').length == 0) {
            return; // Result-Div is not shown
        }

        while (elem.prop("tagName") != 'HTML' && !elem.hasClass(targetClass)) {
            elem = elem.parent();
        }

        if (elem.prop("tagName") == 'HTML') {
            $(targetClass).html('').removeClass('results').addClass('no-results');
        }

    });
}

function indexedSearchAutocomplete(e) {
    var $input = $(this);
    var $elem = $(this);
    var $results;
    while ($elem.prop("tagName") !== 'HTML') {
        $results = $elem.find('.search-autocomplete-results');
        if ($results.length > 0) {
            break;
        }
        $elem = $elem.parent();
    }
    if ($elem.prop("tagName") === 'HTML') {
        console.log("we couldn't find a result div (.search-autocomplete-results)");
        return;
    }

    var mode = typeof $results.data('mode') === 'undefined' ? 'word' : $results.data('mode');
    var soc = $results.data('searchonclick') == true;

    if (e.type !== 'keyup') {
        return;
    }

    $results.html('').removeClass('results').addClass('no-results');

    var val = $(this).val();
    var minlen = typeof $results.data('minlength') === 'undefined' ? 3 : $results.data('minlength');
    var maxResults = typeof $results.data('maxresults') === 'undefined' ? 10 : $results.data('maxresults');


    if (val.length < minlen) {
        return;
    }

    $results.addClass('autocomplete_searching');

    // Debounce
    clearInterval(indexedSearchAutocompleteDebounceInterval);
    indexedSearchAutocompleteDebounceInterval = setInterval(function() {
        clearInterval(indexedSearchAutocompleteDebounceInterval);

        // Execute the query
        $.ajax({
            url: $results.data('searchurl'),
            cache: false,
            method: 'POST',
            data: {
                tx_igshop2_feshop: {
                    searchword: val
                }
            },
            success: function (data) {
                $results
                    .show()
                    .html(data)
                    .removeClass('autocomplete_searching');

                var $product = $results.find('.ajax-product');
                if($product.length) {
                    $('#indexedsearch').prop('action', $('#indexedsearch').data('shopSearchUrl')).prop('method', 'get');
                    wordSearch = false;
                } else {
                    $('#indexedsearch').prop('action', $('#indexedsearch').data('indexedSearchUrl')).prop('method', 'post');
                    wordSearch = true;
                }

                var $word = $results.find('.ajax-word a');
                $word.click(function (e) {
                    var $this = $(this);
                    e.preventDefault();
                    $input.val($(this).text().trim());
                    //$results.html('').hide();
                    wordSearch = true;
                    $('#indexedsearch').prop('method', 'post');
                    $('#indexedsearch').prop('action', $('#indexedsearch').data('indexedSearchUrl'));
                    $('#indexedsearch').submit();
                });

                $('.ajax-all-products a').click(function(e) {
                    e.preventDefault();
                    $(this).parents('form').submit();
                });

                var $category = $results.find('.ajax-category');

                if (!$word.length && !$product.length && !$category.length) {
                    //$results.html('').hide();
                    $results.removeClass('results').addClass('no-results');
                } else {
                    $results.removeClass('no-results').addClass('results');
                }
            }
        });
    }, 250);
}
